<template>
  <v-dialog v-model="isOpen" max-width="800px" scrollable persistent>
    <v-card :tile="$vuetify.breakpoint.smAndDown">
      <!-- Title -->
      <v-card-title>{{ $t('agreement.title') }}</v-card-title>

      <!-- Content -->
      <v-card-text>
        <!-- Error Handler -->
        <suspense-mutation :mutation="agreementsMutation" transition="fade-transition" transition-mode="out-in">
          <!-- Error -->
          <template #error>
            <v-alert class="studium-alert" dense text type="error">
              {{ agreementsMutationError.message }}
            </v-alert>
          </template>
        </suspense-mutation>

        <!-- Description -->
        <p>{{ $t('agreement.desc_welcome') }}</p>
        <p>{{ $t('agreement.desc') }}</p>

        <!-- Checkbox terms of services -->
        <template v-if="!acceptedTerms">
          <v-checkbox v-model="checkboxes.terms" hide-details="auto">
            <template #label>
              <div>
                {{ $t('agreement.agreed') }}
                <v-tooltip bottom>
                  <template #activator="{ on }">
                    <a class="studium-clickable-text" target="_blank" href="/agreements/terms" @click.stop v-on="on">
                      {{ $t('agreement.terms') }}
                    </a>
                  </template>

                  {{ $t('agreement.open_terms') }}
                </v-tooltip>
                .
              </div>
            </template>
          </v-checkbox>
        </template>

        <!-- Checkbox privacy agreement -->
        <template v-if="!acceptedPrivacy">
          <v-checkbox v-model="checkboxes.privacy" hide-details="auto">
            <template #label>
              <div>
                {{ $t('agreement.agreed') }}
                <v-tooltip bottom>
                  <template #activator="{ on }">
                    <a class="studium-clickable-text" target="_blank" href="/agreements/privacy" @click.stop v-on="on">
                      {{ $t('agreement.privacy') }}
                    </a>
                  </template>

                  {{ $t('agreement.open_privacy') }}
                </v-tooltip>
                .
              </div>
            </template>
          </v-checkbox>
        </template>
      </v-card-text>

      <!-- Actions -->
      <v-card-actions>
        <v-spacer />

        <v-tooltip top :disabled="checkboxes.terms && checkboxes.privacy">
          <template #activator="{ on }">
            <div v-on="on">
              <v-btn
                class="studium-button"
                color="primary"
                text
                :ripple="false"
                :disabled="!checkboxes.terms || !checkboxes.privacy"
                :loading="agreementsMutation.loading.value"
                @click="agreementsMutation.mutate()"
              >
                {{ $t('agreement.accept') }}
              </v-btn>
            </div>
          </template>

          {{ $t('agreement.check_all') }}
        </v-tooltip>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { computed, defineComponent, reactive, ref, watch } from '@nuxtjs/composition-api'

import { useAcceptAgreementsMutation, useAcceptedAgreementQuery } from '~/apollo/operations'
import { useErrorHandler } from '~/util/composables'

export default defineComponent({
  setup() {
    const isOpen = ref(false)

    // Checkboxes
    const checkboxes = reactive({
      privacy: false,
      terms: false,
    })

    // If the user accepted the privacy agreement (true if the agreement is null)
    const acceptedPrivacyQuery = useAcceptedAgreementQuery({ url: '/agreements/privacy' })
    const acceptedPrivacy = computed(() => acceptedPrivacyQuery.result.value?.acceptedAgreement ?? true)
    acceptedPrivacyQuery.onResult(() => {
      checkboxes.privacy = acceptedPrivacy.value
    })

    // If the user accepted the terms of services (true if the agreement is null)
    const acceptedTermsQuery = useAcceptedAgreementQuery({ url: '/agreements/terms' })
    const acceptedTerms = computed(() => acceptedTermsQuery.result.value?.acceptedAgreement ?? true)
    acceptedTermsQuery.onResult(() => {
      checkboxes.terms = acceptedTerms.value
    })

    // Update "isOpen" both queries are done loading and at least one has false as a result
    watch(
      () => [acceptedPrivacy.value, acceptedTerms.value],
      ([acceptedPrivacy, acceptedTerms]) => {
        // If at least one privacy agreement is not accepted, open the dialog
        if (!acceptedPrivacy || !acceptedTerms) isOpen.value = true
      },
      { immediate: true }
    )

    // Accept mutation
    const agreementsMutation = useAcceptAgreementsMutation({})
    const agreementsMutationError = useErrorHandler(agreementsMutation)

    // Refetch the agreements when the user has accepted them.
    agreementsMutation.onDone(() => {
      // Close the privacy agreement
      isOpen.value = false
    })

    return {
      isOpen,
      checkboxes,
      acceptedPrivacyQuery,
      acceptedPrivacy,
      acceptedTermsQuery,
      acceptedTerms,
      agreementsMutation,
      agreementsMutationError,
    }
  },
})
</script>
